
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Java编程思想(九) —— 通过异常处理错误(1) / 憋错料</title>

    <meta name="description" content="Java编程思想(九) —— 通过异常处理错误(1) 前阵子看到一个编程的学习方法--橡皮鸭调试法,就是拿一只小黄鸭. 面对面,跟他讲解你的编程思路,如果你没有橡皮鸭或者是一个能听你讲java,c,cpp,前端,io,系统内核,汇编,数据结构,计算机网络的女朋友,那么写博客也是你自己梳理好思路的一个好方法. 书中原话:java的基本理念是结构不佳的代码不能运行. 其实我之前也搞不懂为什么要弄个这样的东西出来,其实跟书上讲的一样,&quot;异常&quot;有&quot;对此感到意外&quot;的意思,问题出现了,我们不知道怎么处理,但又不能置之不理 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Java编程思想(九) —— 通过异常处理错误(1)</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>前阵子看到一个编程的学习方法——橡皮鸭调试法，就是拿一只小黄鸭。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA5MTExMDEyMDMxMTI/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2YVdGcGRHaz0vZm9udC81YTZMNUwyVC9mb250c2l6ZS80MDAvZmlsbC9JMEpCUWtGQ01BPT0vZGlzc29sdmUvNzAvZ3Jhdml0eS9Tb3V0aEVhc3Q=.jpg"></p>
<p>面对面，跟他讲解你的编程思路，如果你没有橡皮鸭或者是一个能听你讲java，c，cpp，前端，io，系统内核，汇编，数据结构，计算机网络的女朋友，那么写博客也是你自己梳理好思路的一个好方法。</p>
<p>书中原话：java的基本理念是结构不佳的代码不能运行。</p>
<p>其实我之前也搞不懂为什么要弄个这样的东西出来，其实跟书上讲的一样，“异常”有“对此感到意外”的意思，问题出现了，我们不知道怎么处理，但又不能置之不理，可以停下来，看是否有其他地方处理这样的问题。这样能降低代码的复杂度，如果不使用异常，那你在程序中就要检查并处理这个错误，使用异常之后，就不用在方法下面进行检查，异常机制能够捕获错误。</p>
<p>所谓的“描述正常执行过程中做了什么事”和“出了问题怎么办”代码分离。</p>
<p>举个简单的例子：</p>
<pre>public class Box {
    public static void main(String[] args) {
        int i[] = new int[4];
        Box.change(i, 5, 1);
    }
    static void change(int[] i ,int index,int value){
        i[index] = value;
    }
}</pre>
<p>这个传参如果超越数组边界的话怎么办，这是错误的啊，所以你用在方法中处理好，添加：</p>
<pre>    static void change(int[] i ,int index,int value){
        if(index&gt;i.length){
            System.out.println(&quot;IndexOutOfBound&quot;);
            return;
        }
        i[index] = value;
    }</pre>
<p>这里的处理比较简单，如果这个程序里面有好多这样的问题，那你岂不是要在每一处都写上这个解决方法，这样就太麻烦了，异常就是这样用的。</p>
<pre>  if(index&gt;i.length){
            throw new IndexOutOfBoundsException();
        }</pre>
<p>交给后面再去处理。</p>
<p>1)捕获异常</p>
<p>方法内部抛出异常，方法将在抛出异常的过程中结束，如果不希望方法就此结束，可以用try块来捕获异常。这样就不用每个方法都去加错误检查的代码，把他们一起捕获，对于相同的异常一次性解决。</p>
<pre>try{

}catch(xx){

}catch(xx){

}</pre>
<p>一旦有同类型的异常，便进入catch语句里面处理。</p>
<p>2)创建自定义异常</p>
<pre>public class MyException {
    public void f(){
        System.out.println(&quot;f() throw simple exception!&quot;);
        try {
            throw new SimpleException();
        } catch (SimpleException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }
    public static void main(String[] args) {
        MyException me = new MyException();
        me.f();
    }
}</pre>
<p>这个例子有很多东西可以讲，首先，如果用了</p>
<pre>throw new SimpleException();</pre>
<p>那么，就要像上面一样加上try和catch。</p>
<p>或者，直接在方法中抛出：</p>
<pre>    public void f() throws SimpleException{
        System.out.println(&quot;f() throw simple exception!&quot;);
            throw new SimpleException();
    }</pre>
<p>但是这样直接抛出之后，</p>
<pre>me.f();</pre>
<p>就有问题了，以为异常抛出了，要么你在main方法中继续抛出：</p>
<pre>    public static void main(String[] args) throws SimpleException {
        MyException me = new MyException();
        me.f();
    }</pre>
<p>要么你在main方法中捕获异常进行处理：</p>
<pre> public static void main(String[] args) {
        MyException me = new MyException();
        try {
            me.f();
        } catch (SimpleException e) {
            System.err.println(&quot;catch it!&quot;);
        }
    }</pre>
<p>err输出为标准错误流，out输出为标准输出，err的话在控制台会以红色字体显示，比较醒目。</p>
<p>但你会发现输出结果是catch it！ 然后才是f() throw simple exception。这个后面再提。</p>
<pre>        try {
            me.f();
        } catch (SimpleException e) {
            e.printStackTrace(System.out);
        }
result:
son.SimpleException
&#160;&#160; &#160;at son.MyException.f(MyException.java:8)
&#160;&#160; &#160;at son.MyException.main(MyException.java:13)
</pre>
<p>printStackTrace()，栈跟踪，打印的是从方法调用处直到异常抛出处，默认无参数的话会输出到标准错误流。</p>
<p>3)记录日志</p>
<p>其实大型的网站，每天都有记录日志，哪里有错误再去日志里找，究竟发生了什么问题。</p>
<pre>public class LoggingException extends Exception{
    private static Logger logger = Logger.getLogger(&quot;LoggingException&quot;);
    public LoggingException(){
        StringWriter sw = new StringWriter();
        printStackTrace(new PrintWriter(sw));
        logger.severe(sw.toString());
    }
    public static void main(String[] args) {
        try {
            throw new LoggingException();
        } catch (LoggingException e) {
            System.err.println(&quot;catch &quot;+e);
        }
    }
}
result:
九月 10, 2014 7:35:50 下午 son.LoggingException &lt;init&gt;
严重: son.LoggingException
&#160;&#160; &#160;at son.LoggingException.main(LoggingException.java:16)

catch son.LoggingException
</pre>
<p>new PrintWriter(sw) 将输出抽取为String。</p>
<p>PrintWriter的话作为参数传进去，后面IO的时候再了解。</p>
<p>Logger,A Logger object is used to log messages for a specific system</p>
<p>or application component.</p>
<p>serve方法，Log a SEVERE message。</p>
<p>4)异常说明</p>
<p>Java鼓励人们把方法可能会抛出的异常告知使用此方法的客户端程序员。如果有源代码，那么客户端程序员可以通过查找throw语句获知抛出的异常。然而源代码一般不提供。</p>
<p>java提供了相应的语法，书上写得很有趣，说以&#31036;貌的方式告诉客户端程序员某个方法可能会抛出的异常类型，他们可以进行相应的处理，这就是异常说明。</p>
<p>其实就是上面提到的不用try，catch而使用到的throws。</p>
<p>5)printStackTrace</p>
<p>我之前翻译成栈跟踪了，书上写的是栈轨迹，其实方法返回的是栈轨迹元素组成的数组，0为栈顶元素，先进后出，这是栈的特性。</p>
<pre>public class TestElement {
    static void first(){
        try {
            throw new Exception();
        } catch (Exception e) {
            // 栈元素  拿到方法名
            for(StackTraceElement s : e.getStackTrace()){
                System.out.println(s.getMethodName());
            }
        }
    }
    static void second(){first();}
    static void third(){second();}
    public static void main(String[] args) {
        first();
        System.out.println(&quot;////////////////&quot;);
        second();
        System.out.println(&quot;////////////////&quot;);
        third();
    }
}
result：
first
main
////////////////
first
second
main
////////////////
first
second
third
main
</pre>
<p>整个栈元素的信息都可以逐一显示。</p>
<p>这篇先讲解基本的异常概念，理清一下为什么使用异常的思路，下一篇，讲到try，catch嵌套这更有深度的内容的时候，更加精彩！</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 07:08:04 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/exception/" title="exception">exception</a>, <a href="https://www.biecuoliao.com/tag/java%e7%bc%96%e7%a8%8b%e6%80%9d%e6%83%b3/" title="java编程思想">java编程思想</a>, <a href="https://www.biecuoliao.com/tag/%e5%bc%82%e5%b8%b8/" title="异常">异常</a>, <a href="https://www.biecuoliao.com/tag/%e6%a0%88%e8%b7%9f%e8%b8%aa/" title="栈跟踪">栈跟踪</a>, <a href="https://www.biecuoliao.com/tag/%e5%bc%82%e5%b8%b8%e5%a4%84%e7%90%86/" title="异常处理">异常处理</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Java编程思想(九) —— 通过异常处理错误(1)的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0bq7boM.html" rel="bookmark">Java编程思想&lpar;十一&rpar; &mdash;&mdash; 通过异常处理错误&lpar;2&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前面一篇提到异常的基本概念和使用的原因,后面一截比较难,然后就分开写出来. 1)finally清理 对于一些代码,无论try有无抛出,都希望执行,为了这样可以在异常处理最后加上finally语句.印象最深的是与数据库打交道的时候,finally永远要记得回收Connection等等. 这样无论异常是否抛出,finally子句总能被执行.这样就不怕发生内存中的资源一直占用的情况,印象深刻的还有老师讲的,公司一个新来的忘记写finally语句,后面内存的东西越来越多,整个系统死掉了. 有一个特别的是			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4AGmL50.html" rel="bookmark">Java编程思想&lpar;九&rpar; &mdash;&mdash; 持有对象&lpar;2&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				11)Map 作者说将对象映射到其他对象的能力是解决编程问题的杀手锏. 确实,例如查看随机数的分布,如果真是随机数的话,那么10000次产生20以内的随机数,每个数字出现的次数应该是相近的. public class TestMap { public static void main(String[] args) { Map&lt;Integer,Integer&gt; map = new HashMap&lt;Integer,Integer&gt;(); Random r = new Random(47			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/74Q8l3R.html" rel="bookmark">异常笔记--java编程思想</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				开一个新的系列,主要记一些琐碎的重要的知识点,把书读薄才是目的...特点: 代码少,概念多... 1. 基本概念 异常是在当前环境下无法获得必要的信息来解决这个问题,所以就需要从当前环境跳出,就是抛出异常.抛出异常后发生的几件事: 1.在堆上创建异常对象. 2.当前的执行路径中止                                          3. 当前环境抛出异常对象的引用.                                         4. 异常处理机制接			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3wrOwQ0.html" rel="bookmark">《Java编程思想&lpar;第4版&rpar;》pdf</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				下载地址:网盘下载 内容简介 编辑 本书赢得了全球程序员的广泛赞誉,即使是最晦涩的概念,在Bruce Eckel的文字亲和力和小而直接的编程示例面前也会化解于无形.从Java的基础语法到最高级特性(深入的面向对象概念.多线程.自动项目构建.单元测试和调试等),本书都能逐步指导你轻松掌握.[1] 从本书获得的各项大奖以及来自世界各地的读者评论中,不难看出这是一本经典之作.本书的作者拥有多年教学经验,对C.C++以及Java语言都有独到.深入的见解,以通俗易懂及小而直接的示例解释了一个个晦涩抽象的概			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MGDKlZ0.html" rel="bookmark">java编程思想总结（三）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				java编程思想总结(三) java编程思想总结是一个持续更新的系列,是本人对自己多年工作中使用到java的一个经验性总结,也是温故而知新吧,因为很多基础的东西过了这么多年,平时工作中用不到也会遗忘掉,所以看看书,上上网,查查资料,也算是记录下自己的笔记吧,过一段时间之后再来看看也是蛮不错的,也希望能帮助到正在学习的人们,本系列将要总结一下几点: 面向对象的编程思想 java的基本语法 一些有趣的框架解析 实战项目的整体思路 代码的优化以及性能调优的几种方案 整体项目的规划和视角 其它遗漏的东西			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/41VJpJM.html" rel="bookmark">java编程思想笔记&lpar;第一章&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Alan Kay 第一个定义了面向对象的语言 1.万物皆对象 2.程序是对象的集合,他们彼此通过发送消息来调用对方. 3.每个对象都拥有由其他对象所构成的存储 4.每个对象都拥有其类型(TYpe) 5.某一特定类型的所有对象都可以接收同样的消息. Booch提出一种更简洁的描述: 对象拥有状态(state) 行为(behavior) 和标识(identity) 每个对象都有一个接口 每个对象都属于定义了特性和行为的某个类(特性可以理解为属性的状态,行为可以理解为method) 在面向对象的程序设			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4A5znZ4.html" rel="bookmark">《Java编程思想》读书笔记</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 这个月一直没更新,就是一直在读这本&lt;Java编程思想&gt;,这本书可以在Java业界被传神的一本书,无论谁谈起这本书都说好,不管这个人是否真的读过这本书,都说啊,这本书很好.然后再看这边书的厚度,哇塞,厚的真的不止一点点,所以很多人看了没多久就放弃了,看不下去,但是基于它的厚度,就说,这是一本好书.也有人说,看了没什么用的一本书,甚至还去嘲笑那些正在看的人,说还不如看点实际的技术.那么在我的世界里,如果一本书没有读过,如果妄加评论的话,没有任何的意义.所以我真的仔仔细细读了下来,书上也写了很			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/41Kydo0.html" rel="bookmark">Java编程思想&lpar;第4版&rpar;pdf高清版免费下载</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				下载地址:网盘下载 备用地址:网盘下载 内容简介编辑本书赢得了全球程序员的广泛赞誉,即使是最晦涩的概念,在Bruce Eckel的文字亲和力和小而直接的编程示例面前也会化解于无形.从Java的基础语法到最高级特性(深入的面向对象概念.多线程.自动项目构建.单元测试和调试等),本书都能逐步指导你轻松掌握.[1] 从本书获得的各项大奖以及来自世界各地的读者评论中,不难看出这是一本经典之作.本书的作者拥有多年教学经验,对C.C++以及Java语言都有独到.深入的见解,以通俗易懂及小而直接的示例解释了一			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/ME2XBX0.html" rel="bookmark">Java编程思想【Thinking in java】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java编程思想[Thinking in java]目录:第1章 对象导论1.1抽象过程1.2每个对象都有一个接口1.3每个对象都提供服务1.4被隐藏的具体实现1.5复用具体实现1.6继承1.6.1“是一个”(is-a)与“像是一个”(is-like-a)关系1.7伴随多态的可互换对象1.8单根继承结构1.9容器1.9.1参数化类型(范型)1.10对象的创建和生命周期1.11异常处理:处理错误1.12并发编程1.13Java与Internet1.13.1Web是什么1.13.2客户端编程1.13			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/BMzrzdM.html" rel="bookmark" class="title">如何在前端模版引擎开发中避免使用eval函数</a>
					<div>
						前段时间,想着自己写一个简单的模版引擎,便于自己平时开发demo时使用.于是根据自己对模版引擎的理解,定义自己的模版格式,然后,根据自己定义的格式,编写处理函数,将模版标签中的字符串,解析成可执行的字 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/N4pwBR3.html" rel="bookmark" class="title">mysql 数据库备份</a>
					<div>
						(2)使用命令行工具 备份数据库: mysqldump –user=root –password=root密码 –lock-all-tables 数据库名 &gt; 备份文件.sql 恢复数据库: m ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/x0d8LZ0.html" rel="bookmark" class="title">HTTP深入浅出个人总结</a>
					<div>
						http遵循request/response模型 基本流程:web浏览器向web服务器发送请求,web服务器处理请求并回应web浏览器 具体步骤: 1.建立tcp连接 web浏览器通过网络(inter ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGEP863.html" rel="bookmark" class="title">C&plus;&plus;程序设计方法3：default修饰符</a>
					<div>
						编译器自动生成的成员函数 如果以下成员函数用户都没有为类实现,则编译器会自动为类生成他们的缺省的实现 默认构造函数,空函数,什么也不做 析构函数,空函数,什么也不做: 拷贝构造函数-按bit位复制对象 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KyldY4.html" rel="bookmark" class="title">ios linking 链接错误</a>
					<div>
						iOS duplicate symbols for architecture i386 标签: ios错误 2014-09-02 00:00 7400人阅读 评论(0) 收藏 举报  分类: iOS( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mg5G1r3.html" rel="bookmark" class="title">JDK和Tomcat的简单配置（菜鸟巧记一）</a>
					<div>
						JDK和Tomcat的配置 1.先好安装JDK 1.1先到oracle官网下载合适自己的JDK 地址http://www.oracle.com/technetwork/java/javase/down ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/418YLG3.html" rel="bookmark" class="title">1、配置后台登录以及模板引入</a>
					<div>
						(1)项目下.env 是配置数据库的文件 DB_HOST=127.0.0.1 DB_DATABASE=blog DB_PREFIX=blog_ DB_USERNAME=root DB_PASSWORD ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vZvjj3.html" rel="bookmark" class="title">Hyper-v虚拟化</a>
					<div>
						1.打开Hyper-V管理器,新建虚拟机 2.点击下一步,继续设置 3.设置虚拟机名称和存储位置,点击选择打钩,自定义路径 4.设置虚拟机运行内存 5.设置虚拟机设置好的网络 6.创建虚拟磁盘 7创建 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Na6r63.html" rel="bookmark" class="title">bzoj 1013  &lbrack;JSOI2008&rsqb;球形空间产生器sphere（高斯消元）</a>
					<div>
						1013: [JSOI2008]球形空间产生器sphere Time Limit: 1 Sec  Memory Limit: 162 MBSubmit: 3584  Solved: 1863[Subm ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0aOYmq4.html" rel="bookmark" class="title">周事项</a>
					<div>
						本周处理事项: 1.培训学习.总结.考试 2.报销培训费用 3.制作IT课件PPT 4.信安课程学习考试 5.JAVA学习 6.工作,确保能够应对突发情况 7.采购.组装.测试电脑 8.电竞活动协助. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47wNL14.html" rel="bookmark" class="title">如何避免JS变量命名冲突</a>
					<div>
						先看问题: &lt;!doctype html&gt; &lt;html&gt; &lt;head&gt; &lt;meta charset=&quot;UTF-8&quot;&gt; &lt;tit ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzL2K23.html" rel="bookmark" class="title">JS中的for和for in循环</a>
					<div>
						1.for循环通常用来遍历数组或类数组对象 模式1:长度缓存 for(var i=0,max=arr.length;i&lt;max;i++){ //your code } 模式2:逐减,与零比较比与 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzLzXq3.html" rel="bookmark" class="title">linux 安装tomcat中间件</a>
					<div>
						1.首先确认是否已安装jdk.配置好所需要的环境变量,如果未安装好,则需要安装jdk和配置好正确的环境变量. 检查是否安装jdk及环境变量配置:#java -version. 2.如上述安装并配置正确 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rbk8g3.html" rel="bookmark" class="title">后台自动启动appium</a>
					<div>
						首先说明,本人用的exe方式安装的appium. 新建一个.vbs文件,写入以下脚本,记得把D盘换成你自己的盘符. 1.后面taskkill好像没有实际作用..加就加了吧. Set ws = Crea ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rbzLb3.html" rel="bookmark" class="title">抽屉效果学习</a>
					<div>
						1, Ios左右菜单PPRevealSideviewController使用的一些心得 代码编写 http://blog.csdn.net/qjlhlh/article/details/8204563 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLv9Qv3.html" rel="bookmark" class="title">单线通讯--单数据线自定义通讯驱动程序</a>
					<div>
						单数据线自定义通讯驱动程序 简介:在双MCU单片机之间通过一根数据线(GPIO口)进行通讯的驱动(50us中断一次) 发送数据的数据头:定义为90次中断的低电平(50us*90 = 4.5ms) 27 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmN7VX0.html" rel="bookmark" class="title">下载并安装JDK</a>
					<div>
						在目前很多工具的安装使用的前提,都是要安装JDK,因此在这边简单的写下JDK的安装过程,方便自己忘记时查阅,希望也能对其他人有所帮助. 首先,居于自己也是个小白,对JDK的各种理解及用途也不是很清楚明 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QaxPN4.html" rel="bookmark" class="title">HQL实现新闻上一篇下一篇</a>
					<div>
						要实现新闻的上一篇下一篇功能,关键是HQL语句 上一篇:HQL=&quot;from News d where d.id&lt;? order by id desc&quot;; 下一篇:HQL=&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kl2jz3.html" rel="bookmark" class="title">取消a标签在移动端点击时的背景颜色</a>
					<div>
						一.取消a标签在移动端点击时的蓝色  -webkit-tap-highlight-color: rgba(255, 255, 255, 0);  -webkit-user-select: none;  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02oZ7z3.html" rel="bookmark" class="title">Transaction-SQL 游标</a>
					<div>
						该游标是基于Declare Cursor 语法,主要用于Transaction-SQL脚本.存储过程以及触发器中.Transaction-SQL游标在服务器处理由客户端发送到服务器的Transacti ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.023 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
